create table Page (
	idt             integer primary key autoincrement,
	path            text not null,
	page            text not null,
	title           text not null,
	url             text not null,
    is_no_index     integer,
    is_no_follow    integer,
    is_canonical    integer,
	in_link_count	integer,
    out_link_count	integer,
	depth           integer,
    weight          real
) ;

CREATE INDEX PAGE_URL_IDX on Page(url);

create table Links(
	idt_page	integer,
	idt_source	integer,
	anchor		text,
	counter		integer,
	CONSTRAINT FK_SOURCES_REL1 FOREIGN KEY(idt_page) REFERENCES Page(idt),
	CONSTRAINT FK_SOURCES_REL2 FOREIGN KEY(idt_source) REFERENCES Page(idt)
) ;
CREATE INDEX SOURCES_IDX on Sources(idt_page);

create table DownloaderQueue (
    idt             integer primary key autoincrement,
    url             text not null,
    path            text not null,
    document_name   text not null,
    depth           integer,
    perform_done    integer
) ;
CREATE INDEX DOWNLOADER_QUEUE_DONE on DownloaderQueue(perform_done);

create table LinkHeaders (
    url                 text not null,
    content_type        text not null,
    content_length      integer,
    downloaded_length   integer
) ;
CREATE INDEX LINK_HEADERS_URL on LinkHeaders(url);

select P.idt,P.path,P.page,P.title,P.url,P.is_no_index,P.is_no_follow,P.is_canonical,P.in_link_count,P.out_link_count,P.depth,P.weight from Page P,LinkHeaders LH where P.is_no_index=0 and P.is_no_follow=0 and P.is_canonical=0 and P.url=LH.url and content_type like '%html%' order by idt

Filtres.
Pages en 404 tous les types mine:
select P.idt,P.path,P.page,P.title,P.url,P.is_no_index,P.is_no_follow,P.is_canonical,P.in_link_count,P.out_link_count,P.depth,P.weight from Page P where P.title = 'Error 404' order by idt

Pages en 404 en filtrant les HTML:
select P.idt,P.path,P.page,P.title,P.url,P.is_no_index,P.is_no_follow,P.is_canonical,P.in_link_count,P.out_link_count,P.depth,P.weight from Page P,LinkHeaders LH where P.title = 'Error 404' and P.url=LH.url and content_type like '%html%' order by idt

Pages en 404 en filtrant tout sauf HTML:
select P.idt,P.path,P.page,P.title,P.url,P.is_no_index,P.is_no_follow,P.is_canonical,P.in_link_count,P.out_link_count,P.depth,P.weight from Page P,LinkHeaders LH where P.title = 'Error 404' and P.url=LH.url and content_type like '%html%' order by idt


Pages en noindex:
select P.idt,P.path,P.page,P.title,P.url,P.is_no_index,P.is_no_follow,P.is_canonical,P.in_link_count,P.out_link_count,P.depth,P.weight from Page P where P.is_no_index=1 order by idt

Pages Canonical :
select P.idt,P.path,P.page,P.title,P.url,P.is_no_index,P.is_no_follow,P.is_canonical,P.in_link_count,P.out_link_count,P.depth,P.weight from Page P where P.is_canonical=1 order by idt


Garbadge :
recherche des pages avec un mauvais content_type.
select idt,P.url,page,LH.content_type from Page P, LinkHeaders LH where P.url=LH.url and content_type not like '%html%';
select count(idt) from Page P, LinkHeaders LH where P.url=LH.url and content_type not like '%html%';
8   irclog.tar
9   doc
10  pdf

select * from Links where idt_page in (8,9,10)

exemple :

index.html
	<a href="lien1.html">L1</a>
	<a href="lien2.html">L2</a>

lien1.html
	<a href="lien2.html">LL2</a>

lien2.html
	<a href="lien1.html">LL1</a>

insert into Page(idt,page,title,url,depth) values(1,"index.html","Index","http://www.javadevel.com/index.html",1);
AnchoriumPage *pageIndex = [downloaderDelegate foundPageWithName:@"index.html" title:@"Index" url:@"http://www.javadevel.com/index.html" andDepth:1];

[downloaderDelegate foundLinkWithName:@"lien1.html" anchor:@"L1" url:@"http://www.javadevel.com/lien1.html" depth:2 forPage:pageIndex];
insert into Page(idt,page,title,url,depth) values(2,"lien1.html",NULL,"http://www.javadevel.com/lien1.html",2);
insert into Links(idt_page,idt_source,anchor,counter) values(2,1,"L1",count++);

[downloaderDelegate foundLinkWithName:@"lien2.html" anchor:@"L2" url:@"http://www.javadevel.com/lien2.html" depth:2 forPage:pageIndex];
insert into Page(idt,page,title,url,depth) values(3,"lien2.html",NULL,"http://www.javadevel.com/lien2.html",2);
insert into Links(idt_page,idt_source,anchor) values(3,1,"L2",count++);

AnchoriumPage *pageLien1 = [downloaderDelegate getPageFromURL:@"http://www.javadevel.com/lien1.html"];
[downloaderDelegate updatePage:pageLien1 withTitle:@"PageLien1"];
update Page set title="PageLien1" where idt=2;
AnchoriumPage *pageLien2 = [downloaderDelegate getPageFromURL:@"http://www.javadevel.com/lien2.html"];
[downloaderDelegate foundLinkWithPage:pageLien2 anchor:@"LL2" forPage:pageLien1];
insert into Links(idt_page,idt_source,anchor) values(3,2,"LL2");

update Page set title="PageLien2" where idt=3;
insert into Links(idt_page,idt_source,anchor) values(2,3,"LL1");

liens entrant sur lien1.html :
select idt from Page where page='lien1.html';
select L.idt_source, P.Page, P.title, P.url, L.anchor from Links L, Page P where L.idt_page=? and L.idt_source=P.idt;
(avec ? prenant la valeur de idt renvoyé par le premier select).

> select S.idt_source, P.title, S.anchor from Sources S, Page P where S.idt_page=2 and S.idt_source=P.idt;
+------------+------------+--------+
| idt_source | title      | anchor |
+------------+------------+--------+
|          1 | index.html | L1     |
|          3 | lien2.html | LL1    |
+------------+------------+--------+
2 rows in set (0.00 sec)
